#include "LogitechCMFilter.h"
#include "LogitechCMReplicant.h"
#include <InterfaceDefs.h>
#include <Message.h>
#include <List.h>

class _EXPORT LogitechCMFilter;

extern "C"  { _EXPORT extern BInputServerFilter *instantiate_input_filter(void); }

// external function
BInputServerFilter *instantiate_input_filter(void)
{
	return new LogitechCMFilter();
}

LogitechCMFilter::LogitechCMFilter(void)
: BInputServerFilter()
{
	_observatorView = BMessenger(A_RC_APP_SIGNATURE);
}

filter_result LogitechCMFilter::Filter(BMessage *message, BList *outList)
{
	switch (message->what)
	{
	case B_KEY_DOWN:
	case B_UNMAPPED_KEY_DOWN:
	{
		int32 key;
		message->FindInt32("key", &key);
		switch(key)
		{
			case 0x22:	// VERNUM 
			case 0x3B:	// CAPSLOCK ou Pause
			case 0x0F:	// SCROLLLOCK
			{
				if(!_observatorView.IsValid())
					_observatorView = BMessenger(A_RC_APP_SIGNATURE);

				// send message to archive view
				_observatorView.SendMessage(message);
			}
		}
	}
	}
	
	return B_DISPATCH_MESSAGE;
}